
_InitMultiServo:

;MultiServo.c,10 :: 		void InitMultiServo(){
;MultiServo.c,11 :: 		T1CON	     = 0x01;
	MOVLW      1
	MOVWF      T1CON+0
;MultiServo.c,12 :: 		TMR1IF_bit = 0;
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;MultiServo.c,13 :: 		TMR1H	     = 0xFF;
	MOVLW      255
	MOVWF      TMR1H+0
;MultiServo.c,14 :: 		TMR1L	     = 0xFF;
	MOVLW      255
	MOVWF      TMR1L+0
;MultiServo.c,15 :: 		TMR1IE_bit = 1;
	BSF        TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
;MultiServo.c,16 :: 		INTCON     = 0xC0;
	MOVLW      192
	MOVWF      INTCON+0
;MultiServo.c,17 :: 		}
L_end_InitMultiServo:
	RETURN
; end of _InitMultiServo

_Duty:

;MultiServo.c,19 :: 		void Duty(int d, int l){
;MultiServo.c,20 :: 		long dd = 65535 - ((Clock_MHz()/4) * d);	        // High value, change 20 to respective oscillator
	MOVLW      5
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVF       FARG_Duty_d+0, 0
	MOVWF      R4+0
	MOVF       FARG_Duty_d+1, 0
	MOVWF      R4+1
	CALL       _Mul_16x16_U+0
	MOVF       R0+0, 0
	SUBLW      255
	MOVWF      Duty_dd_L0+0
	MOVF       R0+1, 0
	BTFSS      STATUS+0, 0
	ADDLW      1
	SUBLW      255
	MOVWF      Duty_dd_L0+1
	MOVLW      0
	MOVWF      Duty_dd_L0+2
	MOVWF      Duty_dd_L0+3
;MultiServo.c,21 :: 		long ll = 65535 - ((Clock_MHz()/4) *(l - d));		// Low value
	MOVF       FARG_Duty_d+0, 0
	SUBWF      FARG_Duty_l+0, 0
	MOVWF      R0+0
	MOVF       FARG_Duty_d+1, 0
	BTFSS      STATUS+0, 0
	ADDLW      1
	SUBWF      FARG_Duty_l+1, 0
	MOVWF      R0+1
	MOVLW      5
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CALL       _Mul_16x16_U+0
	MOVF       R0+0, 0
	SUBLW      255
	MOVWF      Duty_ll_L0+0
	MOVF       R0+1, 0
	BTFSS      STATUS+0, 0
	ADDLW      1
	SUBLW      255
	MOVWF      Duty_ll_L0+1
	MOVLW      0
	MOVWF      Duty_ll_L0+2
	MOVWF      Duty_ll_L0+3
;MultiServo.c,24 :: 		DTH = dd >> 8;
	MOVF       Duty_dd_L0+1, 0
	MOVWF      R0+0
	MOVF       Duty_dd_L0+2, 0
	MOVWF      R0+1
	MOVF       Duty_dd_L0+3, 0
	MOVWF      R0+2
	MOVLW      0
	BTFSC      Duty_dd_L0+3, 7
	MOVLW      255
	MOVWF      R0+3
	MOVF       R0+0, 0
	MOVWF      _DTH+0
	MOVF       R0+1, 0
	MOVWF      _DTH+1
;MultiServo.c,25 :: 		DTL = dd & 0x00FF;
	MOVLW      255
	ANDWF      Duty_dd_L0+0, 0
	MOVWF      _DTL+0
	MOVF       Duty_dd_L0+1, 0
	MOVWF      _DTL+1
	MOVLW      0
	ANDWF      _DTL+1, 1
;MultiServo.c,27 :: 		PTH = ll >> 8;
	MOVF       Duty_ll_L0+1, 0
	MOVWF      R0+0
	MOVF       Duty_ll_L0+2, 0
	MOVWF      R0+1
	MOVF       Duty_ll_L0+3, 0
	MOVWF      R0+2
	MOVLW      0
	BTFSC      Duty_ll_L0+3, 7
	MOVLW      255
	MOVWF      R0+3
	MOVF       R0+0, 0
	MOVWF      _PTH+0
	MOVF       R0+1, 0
	MOVWF      _PTH+1
;MultiServo.c,28 :: 		PTL = ll & 0x00FF;
	MOVLW      255
	ANDWF      Duty_ll_L0+0, 0
	MOVWF      _PTL+0
	MOVF       Duty_ll_L0+1, 0
	MOVWF      _PTL+1
	MOVLW      0
	ANDWF      _PTL+1, 1
;MultiServo.c,29 :: 		}
L_end_Duty:
	RETURN
; end of _Duty

_map:

;MultiServo.c,33 :: 		long map(long x, long in_min, long in_max, long out_min, long out_max){
;MultiServo.c,34 :: 		return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
	MOVF       FARG_map_x+0, 0
	MOVWF      R4+0
	MOVF       FARG_map_x+1, 0
	MOVWF      R4+1
	MOVF       FARG_map_x+2, 0
	MOVWF      R4+2
	MOVF       FARG_map_x+3, 0
	MOVWF      R4+3
	MOVF       FARG_map_in_min+0, 0
	SUBWF      R4+0, 1
	MOVF       FARG_map_in_min+1, 0
	BTFSS      STATUS+0, 0
	INCFSZ     FARG_map_in_min+1, 0
	SUBWF      R4+1, 1
	MOVF       FARG_map_in_min+2, 0
	BTFSS      STATUS+0, 0
	INCFSZ     FARG_map_in_min+2, 0
	SUBWF      R4+2, 1
	MOVF       FARG_map_in_min+3, 0
	BTFSS      STATUS+0, 0
	INCFSZ     FARG_map_in_min+3, 0
	SUBWF      R4+3, 1
	MOVF       FARG_map_out_max+0, 0
	MOVWF      R0+0
	MOVF       FARG_map_out_max+1, 0
	MOVWF      R0+1
	MOVF       FARG_map_out_max+2, 0
	MOVWF      R0+2
	MOVF       FARG_map_out_max+3, 0
	MOVWF      R0+3
	MOVF       FARG_map_out_min+0, 0
	SUBWF      R0+0, 1
	MOVF       FARG_map_out_min+1, 0
	BTFSS      STATUS+0, 0
	INCFSZ     FARG_map_out_min+1, 0
	SUBWF      R0+1, 1
	MOVF       FARG_map_out_min+2, 0
	BTFSS      STATUS+0, 0
	INCFSZ     FARG_map_out_min+2, 0
	SUBWF      R0+2, 1
	MOVF       FARG_map_out_min+3, 0
	BTFSS      STATUS+0, 0
	INCFSZ     FARG_map_out_min+3, 0
	SUBWF      R0+3, 1
	CALL       _Mul_32x32_U+0
	MOVF       FARG_map_in_max+0, 0
	MOVWF      R4+0
	MOVF       FARG_map_in_max+1, 0
	MOVWF      R4+1
	MOVF       FARG_map_in_max+2, 0
	MOVWF      R4+2
	MOVF       FARG_map_in_max+3, 0
	MOVWF      R4+3
	MOVF       FARG_map_in_min+0, 0
	SUBWF      R4+0, 1
	MOVF       FARG_map_in_min+1, 0
	BTFSS      STATUS+0, 0
	INCFSZ     FARG_map_in_min+1, 0
	SUBWF      R4+1, 1
	MOVF       FARG_map_in_min+2, 0
	BTFSS      STATUS+0, 0
	INCFSZ     FARG_map_in_min+2, 0
	SUBWF      R4+2, 1
	MOVF       FARG_map_in_min+3, 0
	BTFSS      STATUS+0, 0
	INCFSZ     FARG_map_in_min+3, 0
	SUBWF      R4+3, 1
	CALL       _Div_32x32_S+0
	MOVF       FARG_map_out_min+0, 0
	ADDWF      R0+0, 1
	MOVF       FARG_map_out_min+1, 0
	BTFSC      STATUS+0, 0
	INCFSZ     FARG_map_out_min+1, 0
	ADDWF      R0+1, 1
	MOVF       FARG_map_out_min+2, 0
	BTFSC      STATUS+0, 0
	INCFSZ     FARG_map_out_min+2, 0
	ADDWF      R0+2, 1
	MOVF       FARG_map_out_min+3, 0
	BTFSC      STATUS+0, 0
	INCFSZ     FARG_map_out_min+3, 0
	ADDWF      R0+3, 1
;MultiServo.c,35 :: 		}
L_end_map:
	RETURN
; end of _map

_Servo:

;MultiServo.c,37 :: 		void Servo(short *Port, unsigned short pin, signed int angle){
;MultiServo.c,41 :: 		err = 0.0325 * angle;
	MOVF       FARG_Servo_angle+0, 0
	MOVWF      R0+0
	MOVF       FARG_Servo_angle+1, 0
	MOVWF      R0+1
	CALL       _Int2Double+0
	MOVLW      184
	MOVWF      R4+0
	MOVLW      30
	MOVWF      R4+1
	MOVLW      5
	MOVWF      R4+2
	MOVLW      122
	MOVWF      R4+3
	CALL       _Mul_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      Servo_err_L0+0
	MOVF       R0+1, 0
	MOVWF      Servo_err_L0+1
	MOVF       R0+2, 0
	MOVWF      Servo_err_L0+2
	MOVF       R0+3, 0
	MOVWF      Servo_err_L0+3
;MultiServo.c,42 :: 		if(angle > 0)
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      FARG_Servo_angle+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Servo12
	MOVF       FARG_Servo_angle+0, 0
	SUBLW      0
L__Servo12:
	BTFSC      STATUS+0, 0
	GOTO       L_Servo0
;MultiServo.c,43 :: 		angle -= err;
	MOVF       FARG_Servo_angle+0, 0
	MOVWF      R0+0
	MOVF       FARG_Servo_angle+1, 0
	MOVWF      R0+1
	CALL       _Int2Double+0
	MOVF       Servo_err_L0+0, 0
	MOVWF      R4+0
	MOVF       Servo_err_L0+1, 0
	MOVWF      R4+1
	MOVF       Servo_err_L0+2, 0
	MOVWF      R4+2
	MOVF       Servo_err_L0+3, 0
	MOVWF      R4+3
	CALL       _Sub_32x32_FP+0
	CALL       _Double2Int+0
	MOVF       R0+0, 0
	MOVWF      FARG_Servo_angle+0
	MOVF       R0+1, 0
	MOVWF      FARG_Servo_angle+1
L_Servo0:
;MultiServo.c,44 :: 		if(angle < 0)
	MOVLW      128
	XORWF      FARG_Servo_angle+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Servo13
	MOVLW      0
	SUBWF      FARG_Servo_angle+0, 0
L__Servo13:
	BTFSC      STATUS+0, 0
	GOTO       L_Servo1
;MultiServo.c,45 :: 		angle += err;
	MOVF       FARG_Servo_angle+0, 0
	MOVWF      R0+0
	MOVF       FARG_Servo_angle+1, 0
	MOVWF      R0+1
	CALL       _Int2Double+0
	MOVF       Servo_err_L0+0, 0
	MOVWF      R4+0
	MOVF       Servo_err_L0+1, 0
	MOVWF      R4+1
	MOVF       Servo_err_L0+2, 0
	MOVWF      R4+2
	MOVF       Servo_err_L0+3, 0
	MOVWF      R4+3
	CALL       _Add_32x32_FP+0
	CALL       _Double2Int+0
	MOVF       R0+0, 0
	MOVWF      FARG_Servo_angle+0
	MOVF       R0+1, 0
	MOVWF      FARG_Servo_angle+1
L_Servo1:
;MultiServo.c,47 :: 		TurnAngle = map(angle, -90, 90, 1000, 2000);
	MOVF       FARG_Servo_angle+0, 0
	MOVWF      FARG_map_x+0
	MOVF       FARG_Servo_angle+1, 0
	MOVWF      FARG_map_x+1
	MOVLW      0
	BTFSC      FARG_map_x+1, 7
	MOVLW      255
	MOVWF      FARG_map_x+2
	MOVWF      FARG_map_x+3
	MOVLW      166
	MOVWF      FARG_map_in_min+0
	MOVLW      255
	MOVWF      FARG_map_in_min+1
	MOVWF      FARG_map_in_min+2
	MOVWF      FARG_map_in_min+3
	MOVLW      90
	MOVWF      FARG_map_in_max+0
	CLRF       FARG_map_in_max+1
	CLRF       FARG_map_in_max+2
	CLRF       FARG_map_in_max+3
	MOVLW      232
	MOVWF      FARG_map_out_min+0
	MOVLW      3
	MOVWF      FARG_map_out_min+1
	CLRF       FARG_map_out_min+2
	CLRF       FARG_map_out_min+3
	MOVLW      208
	MOVWF      FARG_map_out_max+0
	MOVLW      7
	MOVWF      FARG_map_out_max+1
	CLRF       FARG_map_out_max+2
	CLRF       FARG_map_out_max+3
	CALL       _map+0
	MOVF       R0+0, 0
	MOVWF      Servo_TurnAngle_L0+0
	MOVF       R0+1, 0
	MOVWF      Servo_TurnAngle_L0+1
;MultiServo.c,49 :: 		ServoPort = Port;
	MOVF       FARG_Servo_Port+0, 0
	MOVWF      _ServoPort+0
;MultiServo.c,50 :: 		SS = 0x01 << pin;
	MOVF       FARG_Servo_pin+0, 0
	MOVWF      R0+0
	MOVLW      1
	MOVWF      _SS+0
	MOVLW      0
	MOVWF      _SS+1
	MOVF       R0+0, 0
L__Servo14:
	BTFSC      STATUS+0, 2
	GOTO       L__Servo15
	RLF        _SS+0, 1
	RLF        _SS+1, 1
	BCF        _SS+0, 0
	ADDLW      255
	GOTO       L__Servo14
L__Servo15:
;MultiServo.c,52 :: 		for(ff=0;ff<300;ff++)
	CLRF       Servo_ff_L0+0
	CLRF       Servo_ff_L0+1
L_Servo2:
	MOVLW      128
	XORWF      Servo_ff_L0+1, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      1
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Servo16
	MOVLW      44
	SUBWF      Servo_ff_L0+0, 0
L__Servo16:
	BTFSC      STATUS+0, 0
	GOTO       L_Servo3
;MultiServo.c,53 :: 		Duty(TurnAngle, 20000);
	MOVF       Servo_TurnAngle_L0+0, 0
	MOVWF      FARG_Duty_d+0
	MOVF       Servo_TurnAngle_L0+1, 0
	MOVWF      FARG_Duty_d+1
	MOVLW      32
	MOVWF      FARG_Duty_l+0
	MOVLW      78
	MOVWF      FARG_Duty_l+1
	CALL       _Duty+0
;MultiServo.c,52 :: 		for(ff=0;ff<300;ff++)
	INCF       Servo_ff_L0+0, 1
	BTFSC      STATUS+0, 2
	INCF       Servo_ff_L0+1, 1
;MultiServo.c,53 :: 		Duty(TurnAngle, 20000);
	GOTO       L_Servo2
L_Servo3:
;MultiServo.c,54 :: 		}
L_end_Servo:
	RETURN
; end of _Servo

_MultiServo_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;MultiServo.c,56 :: 		void MultiServo_Interrupt() iv 0x0004 ics ICS_AUTO{
;MultiServo.c,57 :: 		if (TMR1IF_bit){
	BTFSS      TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
	GOTO       L_MultiServo_Interrupt5
;MultiServo.c,58 :: 		if(!pwm_flag) {	    //Start of High level
	MOVF       _pwm_flag+0, 0
	IORWF      _pwm_flag+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L_MultiServo_Interrupt6
;MultiServo.c,59 :: 		pwm_flag = 1;	    //Set flag
	MOVLW      1
	MOVWF      _pwm_flag+0
	MOVLW      0
	MOVWF      _pwm_flag+1
;MultiServo.c,60 :: 		*ServoPort = SS;
	MOVF       _ServoPort+0, 0
	MOVWF      FSR
	MOVF       _SS+0, 0
	MOVWF      INDF+0
;MultiServo.c,61 :: 		TMR1H = DTH;
	MOVF       _DTH+0, 0
	MOVWF      TMR1H+0
;MultiServo.c,62 :: 		TMR1L = DTL;
	MOVF       _DTL+0, 0
	MOVWF      TMR1L+0
;MultiServo.c,63 :: 		TMR1IF_bit = 0;		      //Clear interrupt flag
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;MultiServo.c,64 :: 		return;		        //Return
	GOTO       L__MultiServo_Interrupt18
;MultiServo.c,65 :: 		}
L_MultiServo_Interrupt6:
;MultiServo.c,67 :: 		pwm_flag = 0;	    //Clear flag
	CLRF       _pwm_flag+0
	CLRF       _pwm_flag+1
;MultiServo.c,68 :: 		*ServoPort = 0x00;
	MOVF       _ServoPort+0, 0
	MOVWF      FSR
	CLRF       INDF+0
;MultiServo.c,69 :: 		TMR1H = PTH;
	MOVF       _PTH+0, 0
	MOVWF      TMR1H+0
;MultiServo.c,70 :: 		TMR1L = PTL;
	MOVF       _PTL+0, 0
	MOVWF      TMR1L+0
;MultiServo.c,71 :: 		TMR1IF_bit = 0;	        //Clear Interrupt flag
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;MultiServo.c,72 :: 		return;		        //return
	GOTO       L__MultiServo_Interrupt18
;MultiServo.c,74 :: 		}
L_MultiServo_Interrupt5:
;MultiServo.c,75 :: 		}
L_end_MultiServo_Interrupt:
L__MultiServo_Interrupt18:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _MultiServo_Interrupt

MultiServo____?ag:

L_end_MultiServo___?ag:
	RETURN
; end of MultiServo____?ag
