unsigned char pwm_width;
int pwm_flag = 0;
int DTH,DTL;
int PTH,PTL;
int SS;
short *ServoPort;

//Timer1
//Prescaler 1:1; TMR1 Preload = 61536; Actual Interrupt Time : 2 ms
void InitMultiServo(){
  T1CON	     = 0x01;
  TMR1IF_bit = 0;
  TMR1H	     = 0xFF;
  TMR1L	     = 0xFF;
  TMR1IE_bit = 1;
  INTCON     = 0xC0;
}

void Duty(int d, int l){
  long dd = 65535 - ((Clock_MHz()/4) * d);	        // High value, change 20 to respective oscillator
  long ll = 65535 - ((Clock_MHz()/4) *(l - d));		// Low value

  // Bitwise operation to set the TMR1H & TMR1L
  DTH = dd >> 8;
  DTL = dd & 0x00FF;

  PTH = ll >> 8;
  PTL = ll & 0x00FF;
}

// Interpolation to convert angle to timer0 interrupt value
// Credit to Arduino Library
long map(long x, long in_min, long in_max, long out_min, long out_max){
  return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}

void Servo(short *Port, unsigned short pin, signed int angle){
  int ff;
  float err;
  int TurnAngle;
  err = 0.0325 * angle;
  if(angle > 0)
    angle -= err;
  if(angle < 0)
    angle += err;

  TurnAngle = map(angle, -90, 90, 1000, 2000);

  ServoPort = Port;
  SS = 0x01 << pin;

  for(ff=0;ff<300;ff++)
    Duty(TurnAngle, 20000);
}

void MultiServo_Interrupt() iv 0x0004 ics ICS_AUTO{
  if (TMR1IF_bit){
    if(!pwm_flag) {	    //Start of High level
      pwm_flag = 1;	    //Set flag
      *ServoPort = SS;
      TMR1H = DTH;
      TMR1L = DTL;
      TMR1IF_bit = 0;		      //Clear interrupt flag
      return;		        //Return
    }
    else {	            //Start of Low level
      pwm_flag = 0;	    //Clear flag
      *ServoPort = 0x00;
      TMR1H = PTH;
      TMR1L = PTL;
      TMR1IF_bit = 0;	        //Clear Interrupt flag
      return;		        //return
    }
  }
}